pub fn progress_bar(dark_mode: bool, progress: f32) -> impl egui::Widget + 'static {
    move |ui: &mut egui::Ui| {
        let progress = progress.clamp(0.0, 1.0);
        let fill_color = crate::constants::get_fill_color(dark_mode);
        let desired_width = egui::NumExt::at_least(ui.available_size_before_wrap().x, 96.0);
        let height = ui.spacing().interact_size.y;
        let (outer_rect, response) =
            ui.allocate_exact_size(egui::vec2(desired_width, height), egui::Sense::hover());

        if ui.is_rect_visible(response.rect) {
            let rect = egui::Rect::from_min_size(
                outer_rect.min,
                egui::vec2(
                    egui::NumExt::at_least(outer_rect.width() * progress, outer_rect.height()),
                    outer_rect.height(),
                ),
            );
            ui.painter().rect(rect, 0.0, fill_color, egui::Stroke::NONE);
        }

        response
    }
}
